<template>
  <modal class="arcticmodal-container"
         height="auto"
         name="change-mobile-phone"
         :minWidth="300"
         :resizable="true"
         :adaptive="true"
         :reset="true"
         :delay="1"
         @before-open="$helpers.noscroll(true)"
         @before-close="$helpers.noscroll(false)"
         @opened="focusNewOpen"
         @closed="closeModalWindow"
  >
    <div id="Modal1-1" class="box-modal questionnaire-modal">
      <div class="container m-header">
        <div class="box-modal_close arcticmodal-close" @click="closeModalWindow"></div>
        <div class="row">
          <div class="column">
            <h3>Изменение номера мобильного телефона</h3>
          </div>
        </div>
      </div>
      <div class="container">
        <div class="row" v-if="stepChange">
          <div class="column">
            <label for="mobilePhone">Новый номер мобильного телефона:</label>
            <input type="tel"
                   name="mobilePhone"
                   id="mobilePhone"
                   v-validate="'required|standartMobilePhone'"
                   v-model="newPhone"
                   :guide="true"
                   v-mask="'+7(###)###-####'"
                   :keepCharPositions="true"
                   ref="newPhone"
                   placeholder="+7("
                   autocomplete="off"
                   @input.enter="changeNewPhone"
                   @input="keyup()"
                   :class="{error: bug}"
            >

            <validate-message>
              {{ err }}
            </validate-message>

          </div>

          <div class="checkbox">
            <input type="checkbox"
                   name="processing-agree"
                   id="processing-agree"
                   v-model="processingAgree"
                   @click="blocking = !blocking"
            >
            <label for="processing-agree">
              <span></span>Я даю согласие на <a @click.prevent="$modal.show('consent')" href="#">обработку</a> и хранение моих персональных данных.
            </label>
          </div>

        </div>

        <div class="row" v-else>
          <div class="column" style="margin-top: -30px">

            <sms-form @resend="againSms"
                      :smsFormClass="false"
                      v-if="showSuccess"
                      @change="handleSms"
                      :timeOut="60"
                      v-model="$user.smsCode"
                      ref="smsForm"
            >
              <template slot="title"></template>
              <template slot="'additional-title'">
                <span>На номер <strong>{{newPhone}}</strong> было отправлено SMS с кодом подтверждения. Введите полученный код, чтобы подтвердить номер телефона.</span>
              </template>
              <template slot="change">
                <div class="columns twelve">
                  <a @click="changeNewPhone" class="redefine-phone">Изменить номер телефона</a>
                </div>
              </template>
            </sms-form>

            <div v-if="!showSuccess" class="text-choice-mobile text-center">
              Ваш мобильный телефон успешно изменен на {{newPhone}}
            </div>
          </div>
        </div>
      </div>
      <div class="center" v-if="showSuccess">
          <button @click="checkNewMobilePhone" :class="{button_loading: noActive}" :disabled="blocking">{{btn}}</button>
      </div>

      <consent-to-the-processing-of-personal-data></consent-to-the-processing-of-personal-data>


    </div>
  </modal>
</template>

<script>
  import ChangeDataInProfile from '@/mixins/Profile/ChangeDataInProfile'
  import ConsentToTheProcessingOfPersonalData from '@/pages/Registration/FirstPage/ConsentToTheProcessingOfPersonalData'
  import {errorChangeMobilePhone} from '@/utils/error/change-mobile'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import {REQUIRED_FIELD, LENGHT} from '@/components/Validators/CustomVeeValidateMessage'
  import SmsForm from '@/components/SmsForm'
  import smsErrors from '@/utils/error_mapper/smsErrors';

  const clearData = () => {
    return {
      newPhone: '',
      processingAgree: true,
      btn: 'Изменить',
      err: '',
      blocking: false,
      noActive: false,
      stepChange: true, // true
      codeForNewPhone: '',
      bug: false,
      showSuccess: true
    }
  }
export default {
    name: 'change-mobile-phone-modal',
    components: {
      ConsentToTheProcessingOfPersonalData,
      SuccessMessage,
      SmsForm
    },
    mixins: [
      ChangeDataInProfile
    ],
    data: clearData,
    methods: {
      handleSms (sms) {
        this.codeForNewPhone = sms;
      },
      checkNewMobilePhone () {
        let phone = Number(this.newPhone.match(/\d/g).join(''))
        let sms = Number(this.codeForNewPhone)
        if (this.stepChange === false) {
          if (sms >= 1000) {
            this.$validator.validateAll().then(() => {
              this.blocking = true;
              this.noActive = true;
              this.$backend.api.user.phone.edit({
                mobilePhone: phone,
                smsCode: sms
              })
                .then(() => {
                    this.$store.dispatch('LOAN_GET_ACCOUNTS');
                  this.$user.mobilePhone = this.newPhone;
                  this.showSuccess = false;
                  setTimeout(() => {
                    this.closeModalWindow()
                  }, 60000)
                })
                .catch(e => {
                  this.$error(e, smsErrors, 'Ошибка ввода кода')
                  this.bug = true;
                  this.blocking = false;
                  this.noActive = false
                })
            })
          } else {
            this.err = 'СМС-код заполнен не корректно';
            this.bug = true
          }
        }
        if (this.stepChange === true) {
          if (phone.toString() === this.$user.mobilePhone.replace(/[^\d]/g, '')) {
            this.err = 'Вы ввели текущий номер телефона';
            return
          }
          this.$validator.validateAll().then(() => {
            this.blocking = true;
            this.noActive = true;
              this.$backend.api.user.phone.edit({
              mobilePhone: phone
            })
              .then(() => {
                this.stepChange = false;
                this.blocking = false;
                this.noActive = false;
                this.$nextTick(() => {
                  this.btn = 'Подтвердить';
                  console.log(this.$refs.smsForm);
                  console.log(this.$refs);
                  this.$refs.smsForm.focus()
                })
              })
              .catch(e => {
                console.warn('change phone error', e);
                this.err = errorChangeMobilePhone(e.errors[0].code);
                this.bug = true
              })
              .finally(() => {
                this.blocking = false;
                this.noActive = false
              })
          }).catch((e) => {
            console.warn('change phone catch', e)
          })
        }
      },
      keyup() {
        if ([1, 2, 3, 4, 5, 6, 0].includes(parseInt(this.newPhone))) {
            this.newPhone = '+7('
        } else if (parseInt(this.newPhone) === 8) {
            this.newPhone = '+7('
        } else if (parseInt(this.newPhone) === 9) {
            this.newPhone = '+7(9'
        }
      },
      changeNewPhone () {
        this.stepChange = true;
        this.codeForNewPhone = '';
        this.backTime = true;
        this.$nextTick(() => {
          this.$refs.newPhone.focus()
        })
        this.btn = 'Изменить'
      },
      againSms () {
          this.$backend.api.user.phone.edit({
          mobilePhone: Number(this.newPhone.match(/\d/g).join(''))
        })
          .then(() => {
            this.$toastr.success('Код подтверждения успешно отправлен в SMS')
          })
          .catch(e => {
            this.err = errorChangeMobilePhone(e.errors[0].code)
            this.bug = true
          })
      },
      closeModalWindow () {
        this.$modal.hide('change-mobile-phone')
        Object.assign(this.$data, clearData())
      },
      focusNewOpen () {
        this.$nextTick(() => {
          this.$refs.newPhone.focus()
        })
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(LENGHT)
    }
  }
</script>

<style scoped lang="scss">
  .box-modal {
    margin: 0
  }

  .v--modal-overlay .v--modal-box {
    border-radius: 10px;
  }

  .tabs__content {
    display: block;
  }

  .content-block .white-block h3 {
    margin: 0;
  }

  .container {
    padding-bottom: 0 !important;
  }

  .m-header {
    padding-bottom: 30px !important;
  }

  .slide-fade-enter-active {
    transition: all .3s cubic-bezier(0.1, 0.7, 1.0, 0.1);
  }

  .slide-fade-leave-active {
    transition: all .3s ease-out;
  }

  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  ::-webkit-input-placeholder {
    color: #DED3D3;
  }

  ::-moz-placeholder {
    color: #DED3D3;
  }

  :-ms-input-placeholder {
    color: #DED3D3;
  }

  :-moz-placeholder {
    color: #DED3D3;
  }

  .v--modal {
    height: 100% !important
  }

  a.redefine-phone {
    background: url(/lk/static/img/landing/credit-rating/redefine.png) no-repeat 0 0;
    display: inline-block;
    font-size: 14px;
    color: #b7c6d0;
    font-weight: 500;
    min-height: 20px;
    padding-left: 40px;
    text-decoration: none;
    margin-bottom: 40px;
  }

  a.redefine-phone:hover, .after-time:hover {
    text-decoration: underline;
    cursor: pointer;
  }

  .fieldForSms {
    margin: 25px 10px -30px;
  }
  .text-choice-mobile {
    padding: 20px 0;
    font-weight: 500;
  }
</style>
